#pragma once

#include <vector>
#include <string>
#include <ReTexture/flags.h>

namespace ReTexture {
    class Texture {
    private:
        unsigned int width = 0;
        unsigned int height = 0;
        TextureFormat format;
        TextureFlag flags;
        void load(const std::string& file);
        void loadBMP(const std::string& file);
        void loadPNG(const std::string& file);
        void invertY();
    public:
        std::vector<unsigned char> pixelData;
        explicit Texture(const std::string& file);
        Texture(const std::string& file, const TextureFlag& flags);
        [[nodiscard]] unsigned int getWidth() const;
        [[nodiscard]] unsigned int getHeight() const;
        TextureFormat getTextureFormat();
        TextureFlag getFlags();
    };
}